const ABOUT_CONFIG_CONTRACTID = "@mozilla.org/network/protocol/about;1?what=config";
//const NS_ABOUT_REDIRECTOR_MODULE_CID = Components.ID('{55ad974a-5416-11dc-8314-0800200c9a66}');
const NS_ABOUT_REDIRECTOR_MODULE_CID = Components.ID('{1807a7f8-0d3a-4652-aeb8-83fe92e1b0ed}');
const nsIAboutModule = Components.interfaces.nsIAboutModule;

function AboutHandler() {
  var observerService = Components.classes["@mozilla.org/observer-service;1"]
                          .getService(Components.interfaces.nsIObserverService);
  observerService.addObserver(this, "browser-search-engine-modified", false);
  var ss = Components.classes["@mozilla.org/browser/search-service;1"]
           .getService(Components.interfaces.nsIBrowserSearchService);
  var engine = ss.getEngineByName("about:config");
  this.correctEngineURL(engine);
}
AboutHandler.prototype =
{
  get CONFIG_URI(){return "chrome://aboutconfigsearch/content/configRedirect.xul";},
  /* nsIAboutModule */
  newChannel : function newChannel(aURI) {
    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);
    var ext_uri = ioService.newURI(this.CONFIG_URI, null, null);
    var ext_channel = ioService.newChannelFromURI(ext_uri);
    return ext_channel;
  },
  getURIFlags: function getURIFlags(aURI) {
    return 0;
  },
  /* Correct about:config search engine plugin */
  get searchURL(){return "about:config?q={searchTerms}"},
  observe : function(subject, topic, data){
    if (topic=="browser-search-engine-modified" && data=="engine-added"){
      var engine = subject.QueryInterface(Components.interfaces.nsISearchEngine);
      this.correctEngineURL(engine);
    }
  },
  correctEngineURL : function(aEngine){
    if (!aEngine || aEngine.name!="about:config") return;
    aEngine = aEngine.wrappedJSObject;

    var type="text/html";
    for (var i = 0; i < aEngine._urls.length; ++i) {
       if (aEngine._urls[i].type == type){
         aEngine._urls[i].template=this.searchURL;
       }
    }
  },

  /* Required */
  QueryInterface : function handler_QI(iid) {
    if (iid.equals(Components.interfaces.nsISupports))
      return this;

    if (nsIAboutModule && iid.equals(nsIAboutModule))
      return this;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  }
};

var AboutFactory = {
  createInstance : function(outer, iid) {
    if (outer != null) {
      throw Components.results.NS_ERROR_NO_AGGREGATION;
    }
    return new AboutHandler().QueryInterface(iid);
  }
};

var AboutModule = {
  registerSelf : function(compMgr, fileSpec, location, type) {
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);
    compMgr.registerFactoryLocation(NS_ABOUT_REDIRECTOR_MODULE_CID,
                                    "about:config",
                                    ABOUT_CONFIG_CONTRACTID,
                                    fileSpec,
                                    location,
                                    type);
  },
  unregisterSelf : function(compMgr, fileSpec, location)  {
    compMgr = compMgr.QueryInterface(Components.interfaces.nsIComponentRegistrar);

    compMgr.unregisterFactoryLocation(NS_ABOUT_REDIRECTOR_MODULE_CID, fileSpec);
  },
  getClassObject : function(compMgr, cid, iid) {
    if (cid.equals(NS_ABOUT_REDIRECTOR_MODULE_CID)) {
      return AboutFactory;
    }

    if (!iid.equals(Components.interfaces.nsIFactory)) {
      throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
    }

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },
  canUnload : function(compMgr) {return true;}
};

function NSGetModule(compMgr, fileSpec) {
  return AboutModule;
}